//Lab 06: Design optimal control for a system to minimize quadratic
//performance index (P.I.)

//scilab - 6.0.0
// Operating System : Windows 10, 64-bit

//------------------------------------------------------------------
close;
clc;
clear;
//------------------------------------------------------------------
// System Decription
a=[0 1;1 -3];
b=[0 1]';
c=[1 0];
d=0;
sys=syslin('c',a,b,c,d)

// coefficients of P.I.
Q=[1 0;0 1];
R=1;

// Solution P of the riccati equation and feedback gain that minimizes P.I.
[K,P]=lqr(sys,Q,R);

//Closed loop system with optimal control

sysc=syslin('c',a+b*K,b,c,d)

// Close loop solution
t=0:0.1:10;
[y x]=csim('step',t,sysc);

//Closed loop response
plot(t,x,'thickness',2)
title('Evolution of states using optimal control','fontsize',4)
xlabel('Time t','fontsize',2)
ylabel('Response x(t)','fontsize',2)
set(gca(),"grid",[1 1])
h=legend('x1','x2');
h.font_size = 2;
xset('font size',2)
